/**
 *  This contains vebus device update miscellanious common code.
 */

#include <stdlib.h>
#include <velib/base/types.h>

/**
  * Set a bit at bitIndex
   *
  * @param addr
  * @param bitIndex
  */
void bset (char* addr, int bitIndex)
 {
	 un16 mask, byteIndex;

	 if (bitIndex < 0)
		 return;

	 mask = 1;

	 byteIndex = bitIndex / 8;
	 mask <<= (bitIndex & 0x7);

	 addr[byteIndex] |= mask;
 }


 /**
  * Test a bit at bitIndexx
   *
  * @param addr
  * @param bitIndex
  *
  * @return veTrue if bit is set
  */
veBool btst (char* addr, int bitIndex)
 {
	 un16 mask, byteIndex;

	 if (bitIndex < 0)
		 return veFalse;

	 mask = 1;

	 byteIndex = bitIndex / 8;
	 mask <<= (bitIndex & 0x7);

	 if((addr[byteIndex] & mask) != 0)
		 return veTrue;

	 return veFalse;
 }
