#ifndef _BUS_VALUES_H_
#define _BUS_VALUES_H_

#include <velib/velib_inc_mk2.h>
#include <velib/base/base.h>
#include <velib/nmea2k/n2k.h>
#include <velib/types/ve_item.h>

N2kConverterState vebusN2kStateConverter(void);

void valuesInit(void);
void valuesUpdate(void);
void valuesTick(void);

void valuesActionDoneCallback(Mk2Actions done);
void valuesMasterDeviceFound(void);
void valuesExposeFakeDevice(void);
void valuesInitDoneCallback(void);
void valuesInvalidate(void);
void valuesRamVarObtainedCallback(struct VebusDeviceS* dev, un8 id);
void valuesSetRamVarCallback(struct VebusDeviceS *dev, un8 id);
void valuesSetSettingDoneCallback(struct VebusDeviceS* dev, un8 id);
void valuesSettingChangedCallback(struct VebusDeviceS* dev, un8 id);
veBool vebusIsValidSetting(struct VebusDeviceS* dev, un8 id);

void valuesRegisterExtraBatteryCurrent(void);

#ifdef DBUS
void valuesDbusInit(struct VeItem *root, char const *name);
void valuesDbusPublish(void);
void valuesDbusUpdate(void);
#else
# define valuesDbusInit(root, name)
# define valuesDbusPublish()
# define valuesDbusUpdate()
#endif

#endif
