#ifndef _DEV_REG_H_
#define _DEV_REG_H_

#include <velib/J1939/J1939_acl.h>
#include <velib/vecan/prod_types.h>

#define DEV_REG_DESC_LENGTH		70
#define DEV_REG_DESC_SIZE		(DEV_REG_DESC_LENGTH+1)

typedef struct
{
	// Also used by bootloader, keep location the same.
	J1939Nad	nad;				// primary address...

	// Info about the settings
	un16		format;
	un16		length;
	un16		checksum;

	un16		flags;
	un8			mode;
	un16		currentLimit[4];

	// The settings themselves..
	un8			systemInstance;
	un8			deviceInstanceF0;

	// Second function instance
	J1939Nad	nadF1;
	un8			deviceInstanceF1;

	un8			batInstance;
	un8			batType;
	un8			batInstance2;

	un8			descrField1F0[DEV_REG_DESC_SIZE];
	un8			descrField2F0[DEV_REG_DESC_SIZE];

	un8			descrField1F1[DEV_REG_DESC_SIZE];
	un8			descrField2F1[DEV_REG_DESC_SIZE];

	VeProdMsgDefInvolatile	msgSettings[CFG_PROD_MESSAGE_NUMBER];

	un8			alarmEventInstance;
	un8			ledEventInstance;

	un32		bmsVersion;
	un32		dmcVersion;
} DevRegStored;

VE_EXT DevRegStored devRegStored;
VE_EXT DevRegStored const devRegStoredDefault;

void devRegInit(void);
void devRegDefault(void);
void devRegApply(void);
void devRegUpdate(void);

#endif
