#include <velib/velib_inc_mk2.h>
#include <velib/velib_inc_J1939.h>

#include <velib/nmea2k/n2k.h>

/* From VE.Bus to NMEA 2000 */
N2kConverterState vebusN2kStateConverter(void)
{
	switch (vebusSystem.convState.state)
	{
	case VE_STATE_DOWN:
		return N2K_CONVERTER_STATE_FAULT;

	case VE_STATE_STARTUP:
	case VE_STATE_OFF:
		return N2K_CONVERTER_STATE_OFF;

	case VE_STATE_INVERT_AES:
		return N2K_CONVERTER_STATE_LOW_POWER_MODE;

	case VE_STATE_INVERT_FULL:
	case VE_STATE_INVERT_HALF:
		return N2K_CONVERTER_STATE_INVERTING;

	case VE_STATE_POWER_ASSIST:
		return N2K_CONVERTER_STATE_ASSISTING;

	case VE_STATE_BYPASS:
		return N2K_CONVERTER_STATE_PASSTHRU;

	case VE_STATE_CHARGE:
		switch(vebusSystem.convState.substate)
		{
		case VE_SUBSTATE_CHRG_BULK_STOPPED:
		case VE_SUBSTATE_CHRG_INIT:
			return N2K_CONVERTER_STATE_PASSTHRU;

		case VE_SUBSTATE_CHRG_BULK:
			return N2K_CONVERTER_STATE_BULK;

		case VE_SUBSTATE_CHRG_ABSORPTION_REPEAT:
		case VE_SUBSTATE_CHRG_ABSORPTION_FORCE:
		case VE_SUBSTATE_CHRG_ABSORPTION:
			return N2K_CONVERTER_STATE_ABSORPTION;

		case VE_SUBSTATE_CHRG_STORAGE:
			return N2K_CONVERTER_STATE_STORAGE;

		case VE_SUBSTATE_CHRG_FLOAT:
			return N2K_CONVERTER_STATE_FLOAT;

		case VE_SUBSTATE_CHRG_EQUALISE:
			return N2K_CONVERTER_STATE_EQUALIZE;

		case VE_SUBSTATE_CHRG_UNKNOWN:
		default:
			return N2K_CONVERTER_STATE_UNAVAILABLE;
		}
		break;

	default:
		;
	}

	return N2K_CONVERTER_STATE_UNAVAILABLE;
}
