#include <stdlib.h>
#include <string.h>

#include <bus_values.h>
#include <velib/platform/console.h>
#include <velib/types/ve_dbus_item.h>
#include <velib/utils/ve_logger.h>

/** dbus connection */
static struct VeDbus *dbus;
static const char *dbusName;

void valuesDbusInit(struct VeItem *tree, const char *name)
{
	dbus = veDbusGetDefaultBus();

	if (!dbus) {
		logE("dbus", "connection error, giving up");
		pltExit(10);
		return;
	}

	veDbusItemInit(dbus, tree);
	dbusName = strdup(name);
}

void valuesDbusPublish(void)
{
	veDbusChangeName(dbus, dbusName);
}

void valuesDbusUpdate(void)
{
	veDbusItemUpdate(dbus);
}
